<!DOCTYPE html>
<html lang="de">
	<head>
		<meta charset="utf-8" />
		<title>WED1 - HTML Übung 1: Einführung</title>
		<link rel="icon" href="../HSR.Template.Exercises/icon-document.png" type="image/png">

		<link rel="stylesheet" type="text/css" href="../HSR.Template.Exercises/documentStyle.css">
		<script src="../HSR.Template.Exercises/solutions.js"></script>
		<script src="https://cdn.rawgit.com/google/code-prettify/master/loader/run_prettify.js"></script>
		<style>
			.solutionBox { width: 100%; height: 5em; }
			.marked { background: lightgreen; }
		</style>
	</head>
	<body>
		<h1>
			<a class="backlink" href="../index.html">⇦</a>
			WED1 - HTML <img src="../images/HTML5_Logo.svg" alt="HTML logo" style="height: 1em; width: auto;" /> Übung 1: Einführung
			<button id="showSolutions">Lösungen anzeigen/ausblenden</button>
		</h1>


		<h2>Markup</h2>
		<p>Markieren Sie im folgenden Dokument das Markup.</p>
		<pre style="border: 0.1rem solid silver; padding: 0.5rem;"><!--
-->Dear Tim Sanders
================

Thanks for your order. Your order number is 1234-5678.

------------- -------- ----- -----
Product       quantity price  sum
------------- -------- ----- -----
HTML Book            1 25.90 25.90
CSS Book             2 19.90 39.80
============= ======== ===== =====
Total                    CHF 65.70
------------- -------- ----- -----

Notices
-------
* Will be delivered after we received payment
* Will be shipped economy (~10d)

Best regards

Your Skyshop team<!--
		--></pre>

		<div class="solution">
			<pre style="border: 0.1rem solid silver; padding: 0.5rem;"><!--
-->Dear Tim Sanders<span class="marked">&crarr;
================&crarr;
&crarr;
</span>Thanks for your order. Your order number is 1234-5678.<span class="marked">&crarr;
&crarr;
------------- -------- ----- -----&crarr;
</span>Product<span class="marked">       </span>quantity<span class="marked"> </span>price<span class="marked">  </span>sum<span class="marked"> &crarr;
------------- -------- ----- -----&crarr;
</span>HTML Book<span class="marked">            </span>1<span class="marked"> </span>25.90<span class="marked"> </span>25.90<span class="marked">&crarr;
</span>CSS Book<span class="marked">             </span>2<span class="marked"> </span>19.90<span class="marked"> </span>39.80<span class="marked">&crarr;
============= ======== ===== =====&crarr;
</span>Total<span class="marked">                    </span>CHF 65.70<span class="marked">&crarr;
------------- -------- ----- -----&crarr;
&crarr;
</span>Notices<span class="marked">&crarr;
-------&crarr;
* </span>Will be delivered after we received payment<span class="marked">&crarr;
* </span>Will be shipped economy (~10d)<span class="marked">&crarr;
&crarr;
</span>Best regards<span class="marked">&crarr;
&crarr;
</span>Your Skyshop team<!--
			--></pre>
		</div>


		<h2>Encoding</h2>
		<h3>Encoder Tools</h3>
		<p>Schauen Sie die Begriffe "little endian", "big endian" nach, wenn sie sich vom 1. Semester nicht mehr genau erinnern.</p>
		<ul>
			<li>ASCII &hArr; HEX:
				<a href="http://dolcevie.com/js/converter.html" target="_blank">dolcevie.com/js/converter.html</a>
			</li>
			<li>UTF8/16/32/64 &hArr; HEX:
				<a href="./tools/encoder.html" target="_blank">HEX to text encoder</a>
			</li>
		</ul>

		<h3>Aufgaben</h3>
		<ol style="list-style-type: lower-alpha; ">
			<li>
				Folgender Dateiinhalt ist gegeben (Hex). Versuchen Sie herauszufinden, um was für eine Codierung es sich handelt und wie der Inhalt lautet.
				<pre>
ff fe 57 00 69 00 6c 00 6c 00 6b 00 6f 00 6d 00 6d 00 65 00 6e 00 20
00 7a 00 75 00 20 00 57 00 65 00 62 00 65 00 6e 00 67 00 69 00 6e 00
65 00 65 00 72 00 69 00 6e 00 67 00 20 00 26 00 20 00 44 00 65 00 73
00 69 00 67 00 6e 00 20 00 31 00 2e 00 0d 00 0a 00
				</pre>

				<div class="solution">
					<dl>
						<dt>Encoding</dt>
						<dd>UTF16</dd>
						<dt>Inhalt</dt>
						<dd>Willkommen zu Webengineering &amp; Design 1.</dd>
					</dl>
				</div>
			</li>
			<li>
				Wieso ist eine UTF8-codierte Datei kleiner, als die gleiche Datei UTF16 codiert?

				<div class="solution">
					<p>Bei UTF16 wird jeder Buchstaben in zwei Bytes codiert. Bei UTF8 werden nur nicht ASCII-kompatible Zeichen länger als 1 Byte codiert.</p>
				</div>
			</li>
			<li>
				Wieso ist eine Textdatei, die in UTF8 codiert ist und nur a-aA-Z (keine äöü &amp; Sonderzeichen) enthält identisch mit der selben Datei in ASCII codiert?

				<div class="solution">
					<p>Die ersten 128 Zeichen von UTF8 sind ASCII-kompatibel und somit identisch.</p>
				</div>
			</li>
		</ol>


		<h2>Umlaute</h2>
		<p>Sehen Sie sich die folgende Datei an: <a href="./files/aoeuml.html" target="_blank">files/aoeuml.html</a>. Einige Zeichen werden nicht richtig dargestellt. Finden Sie das Problem und beheben Sie es.</p>
		<div class="solution">
			<pre class="prettyprint"><code class="language-html">&lt;meta charset="ascii" /&gt;</code></pre>
			<p>
				Umlaute sind nicht ASCII kompatibel und werden von UTF8 mit mehr als einem Byte abgespeichert.
				Durch die Interpretation des UTF8 codierten Dokumentes als ASCII werden längere Zeichen als einzelne interpretiert wodurch ein falsches Zeichen dargestellt wird. Lösung:
			</p>
			<pre class="prettyprint"><code class="language-html">&lt;meta charset="utf-8" /&gt;</code></pre>
		</div>


		<h2>Debugging - Fehler erkennen</h2>
		<p>
			Das gegebene HTML <a href="./files/debug.html" target="_blank">debug.html</a> stellt die Bestätigungsseite zum einem Formular dar. Leider funktioniert diese Seite nicht
			wie gewünscht. Nutzen Sie die Browser Developer Tools um die Fehler zu finden.
		<p>
		<p>
			<strong>Hinweis</strong>: Die Devoloper Tools lassen sich in den gängigen Browsern mit F12 öffnen; bei Chrome for Mac [COMMAND+OPT+I]. An den Quelltext einer Seite kommen Sie über das Kontextmenü > Seitenquelltext.
		</p>
		<ol style="list-style-type: lower-alpha;">
			<li>
				Vergleichen Sie die vom Browser interpretierte Struktur mit der im HTML gegebenen Struktur. Welche Mutation hat der Browser vorgenommen?

				<div class="solution">
					<p>Der Browser findet den Abschliessenden SCRIPT-Tag nicht; sämtliches HTML wird als JavaScript eingelesen.</p>
				</div>
			</li>
			<li>
				Finden Sie die Fehler und korrigieren Sie dieses im HTML-Editor mittels <a href="http://validator.w3.org/#validate_by_upload+with_options" target="_blank">validator.w3.org/#validate_by_upload+with_options</a> Korrektur-Tips können Sie mittels [X] Clean up Markup with HTML-Tidy aktivieren.

				<div class="solution">
					<p>Der Browser findet den Abschliessenden SCRIPT-Tag nicht; sämtliches HTML wird als JavaScript eingelesen.</p>
				</div>
			</li>
			<li>
				Lesen Sie im HTML Standard die Eigenschaften des <a href="http://www.w3.org/TR/html5/scripting-1.html#the-script-element" target="_blank">SCRIPT Tags HTML5 </a> (siehe auch tag omission) nach. Warum zeigt der Browser eine derartige Reaktion aufs inkorrekte HTML?


				<div class="solution">
					<p>
						Das SCRIPT-Tag erfordert in jedem Fall einen vollen abschliessenden Tag. Tag Omission (d.h. der Tag-End wird automatisch gesetzt), wird vom SCRIPT Tag nicht unterstützt.
						<strong>Vorsicht</strong>: Ein /&gt; gilt im HTML nicht als abschliessenden Tag; dazu müsste XHTML, welches aber wiederum den vollen End-Tag als REQUIRED voraussetzt.
						Es gibt weitere Tags (wie beispielsweise IFRAME / OPTION / ...), welche ebenfalls einen vollen abschliessenden Tag erfordern.
					</p>
				</div>
			</li>
		</ol>


		<h2>Dokument erstellen</h2>
		<p>Erstellen Sie folgendes HTML Dokument mit dem Titel "Tesla Model S":</p>
		<pre>
Tesla Model S
=============

The Tesla Model S is a full-sized all-electric five-door, luxury liftback, produced by Tesla Motors,
and introduced in June 2012.[10] It scored a perfect 5.0 NHTSA automobile safety rating.
The United States Environmental Protection Agency (EPA) official range for the 2012 Model S Performance model equipped with an 85 kWh battery pack is 265 miles (426 km),
higher than any other electric car at the time.[11][12][13]
EPA rates its energy consumption at 237.5 Wh per kilometer (38 kWh/100 mi) for a combined fuel economy of 89 miles per gallon gasoline equivalent (2.64 L/100 km or 107 mpg-imp).[11][14]

The Model S became the first electric car to top the monthly new car sales ranking in any country,
twice leading in Norway, in September and again in December 2013;[15][16][17][18] and also in Demmark in December 2015.[19]
Global Model S sales passed the 100,000 unit milestone in December 2015.[20]

History
-------
The Model S was styled by Franz von Holzhausen, who previously worked for Mazda North American Operations.[26]
The car was codenamed WhiteStar during research and preliminary development.[1][2][3]

The Model S was announced in a press release on June 30, 2008.[27][28]
The prototype vehicle was displayed at a press conference on March 26, 2009.[29]

Production
----------
Tesla manufactures the Model S at the 5.4 million square foot[39] Tesla Factory in Fremont, California.
For the European market, Tesla assembles and distributes from its European Distribution Center in Tilburg,
the Netherlands.[40] Cars are built and tested in Fremont, California. The battery pack,
the electric motor and parts are disassembled and shipped separately to Tilburg, where the cars are reassembled.[41]
The center occupies a 203,000 sq ft (18,900 m2) industrial building that also serves as a workshop and spare parts warehouse.
Tesla expects the Model S to "pay back" the energy that went into producing the car in fewer than 10,000 miles (16,000 km).[42]
		</pre>

		<figure>
			<figcaption>Hilfe: Das Zieldokument, dargestellt im Firefox Browser:</figcaption>
			<img src="./images/articleTeslaTarget.png" style="height: auto; width: 30em; max-width: 100%;" />
		</figure>

		<div class="solution">
			<a href="./solution/tesla-s-simple-solution.html" target="_blank">solution/tesla-s-simple-solution.html</a>
		</div>


		<h2>HTML korrigieren</h2>
		<p>Validieren Sie folgendes HTML und finden Sie Fehler und Bad Practices. Korrigieren Sie die Fehler in der Zeile unterhalb oder beschreiben Sie die Lösung. Sie werden einige Tags antreffen, die Sie noch nicht kennen. Dies spielt keine Rolle. Die Fehler liegen in der HTML- und Attributstruktur selbst und nicht in der Semantik von Tag-Eigenschaften. </p>
		<p>Hinweise: IMG ist ein Void-Tag.</p>
		<pre class="prettyprint"><code class="language-html"><!--
-->&lt;!-- documenttype: HTML --&gt;
&lt;html lang=”en”&gt;
	&lt;header&gt;
		&lt;meta charset="uft-8" /&gt;
		&lt;title&gt;Cars&lt;/title&gt;
	&lt;/header&gt;
	&lt;body&gt;
		&lt;div font="Arial" id="theUniqueContainer"&gt;
			&lt;img src="./car.jpg" alt="car"&gt;&lt;/img&gt;
			&lt;p id="theUniqueContainer"&gt;
			&lt;/div&gt;
		&lt;/p&gt;
		&lt;form action="./submit" method="POST">
			&lt;textarea name="comment" size=5&gt;&lt;/textarea&gt;
		&lt;/form&gt;
	&lt;body&gt;
	&lt;foot&gt;
		&lt;script src="./jquery.js"&gt;
	&lt;/foot&gt;
&lt;/html&gt;<!--
		--></code></pre>
		<div class="solution">
			<pre class="prettyprint"><code class="language-html"><!--
-->&lt;!-- documenttype: HTML --&gt;
&lt;!DOCTYPE html&gt;
&lt;html lang=”en”&gt;
	&lt;!-- &lt;header&gt; --&gt;
	&lt;head&gt;
		&lt;meta charset="uft-8" /&gt;
		&lt;title&gt;Cars&lt;/title&gt;

	&lt;!-- &lt;/header&gt; --&gt;
	&lt;/head&gt;
	&lt;body&gt;
		&lt;!--
		&lt;div font="Arial" id="theUniqueContainer"&gt;
		font=“Arial“ ist eine Eigenschaft für die visuelle Darstellung und gehört nicht ins HTML
		--&gt;
		&lt;div id="theUniqueContainer">
			&lt;!-- &lt;img src="./car.jpg" alt="car"&gt;&lt;/img&gt; --&gt;
			&lt;img src="./car.jpg" alt="car" />

			&lt;!--
			&lt;p id="theUniqueContainer"&gt;
			ID darf nur einmal im Dokument vorkommen
			--&gt;
			&lt;p id="theNextContainer"&gt;

			&lt;!-- P wurde nicht geschlossen --&gt;
			&lt;/p&gt;
		&lt;/div&gt;
		&lt;!--
		&lt;/p&gt;
		Kein öffnender P-Tag, entfernen
		--&gt;

		&lt;form action="./submit" method="POST">
			&lt;!--
			&lt;textarea name="comment" size=5&gt;&lt;/textarea&gt;
			Attribute müssen von Anführungszeichen umschlossen sein: size=“5“
			--&gt;
			&lt;textarea name="comment" size="5"&gt;&lt;/textarea&gt;
		&lt;/form&gt;

		&lt;!--
		&lt;foot&gt;
		Nicht existierendes Element, Script zuunterst in Body einfügen
		--&gt;
		&lt;!-- Tag schliessen --&gt;
		&lt;script src="./jquery.js"&gt;&lt;/script&gt;

	&lt;!--
	&lt;body&gt;
	Element muss geschlossen werden statt erneut geöffnet
	--&gt;
	&lt;/body&gt;
&lt;/html&gt;<!--
			--></code></pre>
		</div>
	</body>
</html>
